<template>
	<div>
		<h2>{{ value.title }}</h2>
		<div class="row">
			<div class="col-md-12">
				<div class="bubble-wrap">
				<canvas class="bubble-image" :style="bg" ref="container" @click="addBubble"></canvas>				
				<template v-for="(bubble, index) in bubbles">						
					<div class="circle" :style="bubble.style" @click="removeBubble(bubble)">{{ index + 1 }}</div>
				</template>				
				</div>				
			</div>
		</div>
	</div>
</template>

<script>	
	import { config } from './config'

	export default{
		data(){
			return {
				bubbles : []
			}
		},
		computed:{
			bg(){
				return {
					"background" : "url(" + this.value.img + ") no-repeat",
					"background-size" : "contain"
				}
			}
		},
		name	: config.component,
		props	: config.props,
		methods: {

			addBubble(e){
				if(this.bubbles.length > config.options.maxBubbles - 1 ) return ;				
				let pos = this.getCursorPosition(e)

				this.bubbles.push({
					"style" : {
						"position"	: "absolute",	
						"left" 		: pos.x + '%',
						"top" 		: pos.y + '%'
					},
					"value" : {
						"title" 		: "",
						"description" 	: ""
					}
				})
			},
		    removeBubble(bubble) {
	    	let index = this.bubbles.indexOf(bubble)
	      		this.bubbles.splice(index, 1)
		    },
			getCursorPosition(event) {
				let canvas 	= this.$refs.container
			    let rect 	= canvas.getBoundingClientRect()
			    let xRel 	= event.clientX - rect.left
			    let yRel 	= event.clientY - rect.top
			    let x 		= (xRel / canvas.offsetWidth) * 100
			    let y 		= (yRel / canvas.offsetHeight) * 100
			    	return { "x" : x, "y" : y }
			}
		}
	}
</script>

<style>

	.circle{
		display: flex;
		justify-content: center;
		align-content: center;
		width: 30px;
		height: 30px;
		border-radius: 50%;
		background: #3cfd92;		
	  	color: #4f4c4c;
	}

	.bubble-image{
		position: relative;
		width: 100%;
		height: 300px;
	}

	.bubble-wrap{
		position: relative;
	}

</style>